Package: consensusOV
Type: Package
Title: Gene expression-based subtype classification for high-grade
        serous ovarian cancer
Version: 1.35.0
Date: 2024-02-05
Authors@R: c(
  person('Gregory', 'Chen', 'M', role=c('aut')),
  person('Lavanya', 'Kannan', role=c('aut')),
  person('Ludwig', 'Geistlinger', role=c('aut')),
  person('Victor', 'Kofia', role=c('aut')),
  person('Levi', 'Waldron', role=c('aut')),
  person('Christopher', 'Eeles', email='christopher.eeles@uhnresearch.ca', role=c('ctb')),
  person('Benjamin', 'Haibe-Kains', email='benjamin.haibe.kains@utoronto.ca', role=c('aut', 'cre'))
  )
Maintainer: Benjamin Haibe-Kains <benjamin.haibe.kains@utoronto.ca>
Description: This package implements four major subtype classifiers for
    high-grade serous (HGS) ovarian cancer as described by Helland
    et al. (PLoS One, 2011), Bentink et al. (PLoS One, 2012),
    Verhaak et al. (J Clin Invest, 2013), and Konecny et al. (J
    Natl Cancer Inst, 2014). In addition, the package implements a
    consensus classifier, which consolidates and improves on the
    robustness of the proposed subtype classifiers, thereby
    providing reliable stratification of patients with HGS ovarian
    tumors of clearly defined subtype.
License: Artistic-2.0
Depends: R (>= 3.6)
Imports: Biobase, GSVA (>= 1.50.0), gdata, genefu, limma, matrixStats,
        randomForest, stats, utils, methods, BiocParallel
URL: http://www.pmgenomics.ca/bhklab/software/consensusOV
Suggests: BiocStyle, ggplot2, knitr, rmarkdown, magick
VignetteBuilder: knitr
Encoding: UTF-8
RoxygenNote: 7.3.1
LazyData: true
biocViews: Classification, Clustering, DifferentialExpression,
        GeneExpression, Microarray, Transcriptomics
BugReports: https://github.com/bhklab/consensusOV/issues
git_url: https://git.bioconductor.org/packages/consensusOV
git_branch: devel
git_last_commit: fff0f7a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 21:06:34 UTC; biocbuild
Author: Gregory M Chen [aut],
  Lavanya Kannan [aut],
  Ludwig Geistlinger [aut],
  Victor Kofia [aut],
  Levi Waldron [aut],
  Christopher Eeles [ctb],
  Benjamin Haibe-Kains [aut, cre]

[![R-CMD-check](https://github.com/bhklab/consensusOV/workflows/R-CMD-check/badge.svg)](https://github.com/bhklab/consensusOV/actions)

**Bioc-Release**: ![Bioconductor RELEASE](http://bioconductor.org/shields/build/release/bioc/consensusOV.svg)

**Bioc-Devel**: ![Bioconductor DEVEL](http://bioconductor.org/shields/build/devel/bioc/consensusOV.svg)


Overview
--------

This package implements four major subtype classifiers for high-grade serous (HGS) ovarian cancer as described by Helland et al. (PLoS One, 2011), Bentink et al. (PLoS One, 2012), Verhaak et al. (J Clin Invest, 2013), and Konecny et al. (J Natl Cancer Inst, 2014). In addition, the package implements a consensus classifier, which consolidates and improves on the robustness of the proposed subtype classifiers, thereby providing reliable stratification of patients with HGS ovarian tumors of clearly defined subtype.

Author: Gregory M Chen, Lavanya Kannan, Ludwig Geistlinger, *Victor Kofia*, Levi Waldron, *Benjamin Haibe-Kains*

Installation
------------

``` r
# Installing the development version from GitHub:
# install.packages("devtools")
devtools::install_github("bhklab/consensusOV")

# Installing the release version from Bioconductor:
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("consensusOV")
```

Usage
-----
Extensive usage examples are provided in the consensusOV vignette on Bioconductor: [consensusOV.pdf](https://bioconductor.org/packages/release/bioc/manuals/consensusOV/man/consensusOV.pdf)

Getting help
------------

Contact us by filing an issue in the consensusOV [issues](https://github.com/bhklab/consensusOV/issues) page.

#' Merging all individual esets and merging them into a big eset
#'
#' @param esets The list containing all GSE file that need to be merged.
#' @param method either "unique" or "intersect" is use to for selecting geneid
#' @param standardization choose between "quantile", "robust.scaling", "scaling"
#'  or "none"
#' @param nthread number of threads (1 by default)
#' @return The merging eset
#' @importFrom limma normalizeBetweenArrays
#' @import Biobase
dataset.merging <-
    function (esets,
              method = c("union", "intersect"),
              standardization = c("quantile", "robust.scaling", "scaling", "none"),
              nthread = 1) {
        ## function merging all individual esets and merging them into a big eset
        #
        # Args:
        #   esets: The list containing all GSE file that need to be merged.
        #   duplication.checker: A marker, either TRUE or FALSE if you you want
        #                        to verify whether or not you have duplicate
        #                        samples into your master gene expression matrix.
        #   survdata: For t.fs and e.fs
        #   time.cens: maximum follow up (years)
        #   Method: either "unique" or "intersect" is use to for selecting geneid
        #

        method <- match.arg(method)
        standardization <- match.arg(standardization)

        ## all unique Entrez gene ids
        ## gene ids
        ugid <- lapply(esets, function(x) {
            return(Biobase::fData(x))
        })
        ugid <- do.call(rbind, ugid)
        ugid <-
            ugid[!is.na(ugid[, "EntrezGene.ID"]) &
                     !duplicated(ugid[, "EntrezGene.ID"]), , drop = FALSE]
        rownames(ugid) <-
            gsub(sprintf("(%s).", paste(names(esets), collapse = "|")), "",
                 rownames(ugid))
        switch (method,
                "union" = {
                    feature.merged <- ugid
                },
                "intersect" = {
                    feature.merged <-
                        lapply(esets, function(x) {
                            return(base::trimws(
                                as.character(
                                    Biobase::fData(x)[, "EntrezGene.ID"]
                                )
                            ))
                        })
                    feature.merged <- table(unlist(feature.merged))
                    feature.merged <-
                        names(feature.merged)[feature.merged == length(esets)]
                    feature.merged <-
                        ugid[match(feature.merged, base::trimws(
                            as.character(ugid[, "EntrezGene.ID"]))),
                            ,
                            drop = FALSE]
                },
                {
                    stop("Unknown method")
                })
        ## expression data
        exprs.merged <- lapply(esets, function (x, y) {
            ee <- Biobase::exprs(x)[is.element(rownames(exprs(x)),
                                               rownames(feature.merged)),]
            #print(dim(ee))
            eem <-
                matrix(
                    NA,
                    nrow = length(y),
                    ncol = ncol(ee),
                    dimnames = list(y, colnames(ee))
                )
            #print(dim(eem))
            #print(length(intersect(rownames(ee),rownames(eem))))
            eem[rownames(ee), colnames(ee)] <- ee
            return (eem)
        }, y = rownames(feature.merged))
        exprs.merged <- do.call(cbind, exprs.merged)
        ## clinical info
        ucid <-
            lapply(esets, function(x) {
                return(colnames(Biobase::pData(x)))
            })
        ucid <- table(unlist(ucid))
        ucid <- names(ucid)[ucid == length(esets)]
        clinicinfo.merged <- lapply(esets, function (x , y) {
            ee <- Biobase::pData(x)[, y, drop = FALSE]
        }, y = ucid)
        clinicinfo.merged <- do.call(gdata::combine, clinicinfo.merged)
        # if a data.source column already exists, remove it
        clinicinfo.merged$data.source <- NULL
        colnames(clinicinfo.merged)[
            which(colnames(clinicinfo.merged) == "source")
        ] <- "data.source"
        rownames(clinicinfo.merged) <- colnames(exprs.merged)
        #   rownames(clinicinfo.merged) <- gsub(   sprintf("(%s).",
        # paste(names(esets), collapse="|")), "", rownames(clinicinfo.merged)
        #   ## create a merged expressionSet object
        eset.merged <-
            ExpressionSet(
                assayData = exprs.merged,
                phenoData = AnnotatedDataFrame(data = clinicinfo.merged),
                featureData = AnnotatedDataFrame(data = feature.merged)
            )
        experimentData(eset.merged)@preprocessing <-
            list("normalization" = "mixed",
                 package = "unspecified",
                 version = "0")
        annotation(eset.merged) <- "mixed"
        ## subtyping
        # Note that experimentData does not subset according to other
        # ExpressionSet fields. For now, this section is commented out.
        #  sbtn <- lapply(esets, function (x) {
        #    return (colnames(getSubtype(eset=x, method="fuzzy")))
        #  })
        #  if (!all(sapply(sbtn, is.null))) {
        #    sbtn <- table(unlist(sbtn))
        #    if (!all(sbtn == length(esets))) {
        #       stop("Different subtyping across esets")
        #    }
        #    sclass <- lapply(esets, getSubtype, method="class")
        ##     nn <- unlist(sapply(sclass, names))
        ##     sclass <- unlist(sclass)
        ##     names(sclass) <- nn
        ##     names(sclass) <- names(esets)
        #    sclass <- unlist(sclass)
        #    names(sclass) <- unlist(sapply(esets, sampleNames))
        #    sfuzzy <- do.call(rbind, lapply(esets, getSubtype, method="fuzzy"))
        #    rownames(sfuzzy) <- sampleNames(eset.merged)
        #    scrisp <- do.call(rbind, lapply(esets, getSubtype, method="crisp"))
        #    message("going to set the subtype")
        #    eset.merged <- setSubtype(eset=eset.merged, subtype.class=sclass,
        #    subtype.fuzzy=sfuzzy, subtype.crisp=scrisp)
        #    rownames(fData(eset.merged)) <- fData(eset.merged)[,"EntrezGene.ID"]
        #    message("set the subtype complete for merged")
        #  }

        ## standardization
        switch(
            standardization,
            "none" = {
                ## do nothing
            },
            "quantile" = {
                ## robust scaling followed by quantile normalization
                ee <- exprs(eset.merged)
                # ee <- apply(ee, 2, genefu::rescale)
                splitix <-
                    parallel::splitIndices(nx = ncol(ee), ncl = nthread)
                mcres <-
                    parallel::mclapply(splitix, function(x, data) {
                        res <- apply(data[, x, drop = FALSE], 2, function (dx) {
                            return ((genefu::rescale(
                                dx, q = 0.05, na.rm = TRUE
                            ) - 0.5) * 2)
                        })
                        return (res)
                    }, data = ee, mc.cores = nthread)
                ee <- do.call(cbind, mcres)
                ## quantile normalization
                ee <-
                    normalizeBetweenArrays(object = ee, method = "quantile")
                exprs(eset.merged) <- ee
            },
            "robust.scaling" = {
                ## robust scaling
                ee <- exprs(eset.merged)
                # ee <- apply(ee, 2, genefu::rescale)
                splitix <-
                    parallel::splitIndices(nx = ncol(ee), ncl = nthread)
                mcres <-
                    parallel::mclapply(splitix, function(x, data) {
                        res <- apply(data[, x, drop = FALSE], 2, function (dx) {
                            return ((genefu::rescale(
                                dx, q = 0.05, na.rm = TRUE
                            ) - 0.5) * 2)
                        })
                        return (res)
                    }, data = ee, mc.cores = nthread)
                ee <- do.call(cbind, mcres)
                exprs(eset.merged) <- ee
            },
            "scaling" = {
                ## traditional scaling
                # robust scaling
                ee <- exprs(eset.merged)
                # ee <- apply(ee, 2, genefu::rescale)
                splitix <-
                    parallel::splitIndices(nx = ncol(ee), ncl = nthread)
                mcres <-
                    parallel::mclapply(splitix, function(x, data) {
                        return(apply(data[, x, drop = FALSE], 2, scale))
                    }, data = ee, mc.cores = nthread)
                ee <- do.call(cbind, mcres)
                exprs(eset.merged) <- ee
            },
            {
                stop("Unknown data standardization method")
            }
        )

        return (eset.merged)
    }

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, cache=TRUE)

## ----load_pkgs, message=FALSE-------------------------------------------------
library(consensusOV)
library(Biobase)
library(genefu)

## ----load_data, message=FALSE-------------------------------------------------
data(GSE14764.eset)
dim(GSE14764.eset)
GSE14764.expression.matrix <- exprs(GSE14764.eset)
GSE14764.expression.matrix[1:5,1:5]
GSE14764.entrez.ids <- fData(GSE14764.eset)$EntrezGene.ID
head(GSE14764.entrez.ids)

## ----subtyping----------------------------------------------------------------
bentink.subtypes <- get.subtypes(GSE14764.eset, method = "Bentink")
bentink.subtypes$Bentink.subtypes
konecny.subtypes <- get.subtypes(GSE14764.eset, method = "Konecny")
konecny.subtypes$Konecny.subtypes
helland.subtypes <- get.subtypes(GSE14764.eset, method = "Helland")
helland.subtypes$Helland.subtypes

## ----subtyping2, results="hide"-----------------------------------------------

# to align with the Verhaak subtypes, we need to remove the "geneid." in the rownames
temp_eset <- GSE14764.eset
rownames(temp_eset) <- gsub("geneid.", "", rownames(temp_eset))

verhaak.subtypes <- get.subtypes(temp_eset, method = "Verhaak")

## ----subtyping3---------------------------------------------------------------
verhaak.subtypes$Verhaak.subtypes
consensus.subtypes <- get.subtypes(GSE14764.eset, method = "consensusOV")
consensus.subtypes$consensusOV.subtypes

## ----alternative_subtyping----------------------------------------------------
## Alternatively, e.g.
data(sigOvcAngiogenic)
bentink.subtypes <- get.subtypes(GSE14764.expression.matrix, GSE14764.entrez.ids, method = "Bentink")

## ----subtyping_ex_2-----------------------------------------------------------
bentink.subtypes <- get.bentink.subtypes(GSE14764.expression.matrix, GSE14764.entrez.ids)

## ----verhaak_helland, fig.height = 8, fig.width = 8---------------------------
vest <- verhaak.subtypes$gsva.out
vest <- vest[,c("IMR", "DIF", "PRO", "MES")]
hest <- helland.subtypes$subtype.scores
hest <- hest[, c("C2", "C4", "C5", "C1")]
dat <- data.frame(
	as.vector(vest), 
	rep(colnames(vest), each=nrow(vest)),
	as.vector(hest), 
	rep(colnames(hest), each=nrow(hest)))
colnames(dat) <- c("Verhaak", "vsc", "Helland", "hsc")
## plot
library(ggplot2)
ggplot(dat, aes(Verhaak, Helland)) + geom_point() + facet_wrap(vsc~hsc, nrow = 2, ncol = 2)

## ----konecny_helland, fig.height = 8, fig.width = 8---------------------------
kost <- konecny.subtypes$spearman.cc.vals
hest <- helland.subtypes$subtype.scores
hest <- hest[, c("C2", "C4", "C5", "C1")]
dat <- data.frame(
	as.vector(kost), 
	rep(colnames(kost), each=nrow(kost)),
	as.vector(hest), 
	rep(colnames(hest), each=nrow(hest)))
colnames(dat) <- c("Konecny", "ksc", "Helland", "hsc")
## plot
ggplot(dat, aes(Konecny, Helland)) + geom_point() + facet_wrap(ksc~hsc, nrow = 2, ncol = 2)

#' Get ovarian cancer subtypes
#'
#' @param expression.dataset Either a matrix of gene expression values with rows
#'  as genes, columns as samples;
#' or a BioBase::ExpressionSet object from MetaGxOvarian.
#' If \code{expression.dataset} is a matrix, then \code{entrez.ids} must have
#' length equal to the number of rows of \code{expression.dataset}.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.dataset}
#' @param method The subtyping method to use
#' @param ... Optional parameters to be passed to the low level function
#' @return A list with first value \code{Konecny.subtypes} containing a factor
#' of subtype names; and second value \code{spearman.cc.vals} containing the
#' Spearman correlation values per subtype
#' 
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' get.subtypes(expression.matrix, entrez.ids, method="Konecny")
#' 
#' @importFrom methods is
#' 
#' @export
get.subtypes <-
function(expression.dataset, entrez.ids=NULL,
         method=c("consensusOV", "Helland", "Verhaak", "Konecny", "Bentink"),
         ...) {
	method <- match.arg(method)
	if(is.null(entrez.ids) && !is(expression.dataset, "ExpressionSet")) {
		stop("If entrez.ids are not provided, expression.dataset must be of class 'ExpressionSet' from MetaGxOvarian")
	}
	if(!is.null(entrez.ids) && !is(expression.dataset, "matrix")) {
		stop("If entrez.ids are provided, expression.dataset must be of class 'matrix'")
	}
	if(!is.null(entrez.ids) && length(entrez.ids) != nrow(expression.dataset)) {
		stop("The length of entrez.ids must be equal to the number of rows of expression.dataset")
	}
	dataFromMetaGx <- is.null(entrez.ids)

	if(dataFromMetaGx) {
		expression.matrix <- exprs(expression.dataset)
		entrez.ids <- as.character(fData(expression.dataset)$EntrezGene.ID)
	} else {
		expression.matrix <- expression.dataset
	}

	if(method=="consensusOV") {
	  subtypes.output <- get.consensus.subtypes(expression.matrix, entrez.ids, ...)
	} else if(method == "Helland") {
	  subtypes.output <- get.helland.subtypes(expression.matrix, entrez.ids, ...)
	} else if(method == "Verhaak") {
	  subtypes.output <- get.verhaak.subtypes(expression.matrix, entrez.ids, ...)
	} else if(method == "Konecny") {
	  subtypes.output <- get.konecny.subtypes(expression.matrix, entrez.ids, ...)
	} else if(method == "Bentink") {
	  subtypes.output <- get.bentink.subtypes(expression.matrix, entrez.ids, ...)
	}

	return(subtypes.output)
}

#' Get ovarian cancer subtypes as defined by Hao et al., 2017
#'
#' @details Hao et al., 2017 derived a gene signature to predict the tissue 
#' of origin of ovarian tumors as either fallopian tube (FT) or ovarian surface
#' epithelium (OSE).
#' 
#' The authors found that expression patterns of tissue-specific genes, prognostic
#' genes, and molecular markers support a dualistic tissue origin of ovarian cancer, 
#' from either FT or OSE.
#'
#' The subtype classifier considers 112 signature genes including 37 genes
#' upregulated in FT and 75 genes upregulated in OSE. A score is computed
#' that is designed to range from 0 to 1 for FT tumors, while OSE tumors have a 
#' score ranging from -1 to 0.
#'
#' @param expression.matrix A matrix of gene expression values with genes as
#' rows, samples as columns.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}.
#' @return A list with first value \code{tissue} containing a factor
#' of subtype names (tissue of origin); and second value \code{score} containing
#' the tissue-of-origin score.
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' get.hao.subtypes(expression.matrix, entrez.ids)
#' @references Hao et al. (2017) Integrated analysis reveals tubal- and
#' ovarian-originated serous ovarian cancer and predicts differential therapeutic
#' responses. Clinical Cancer Research, 23:7400-11.
#' @author Ludwig Geistlinger 
#' @importFrom utils read.delim
#' @export
get.hao.subtypes <- function(expression.matrix, entrez.ids) 
{
    # get the signature 
    sig.file <- system.file("extdata/FT_vs_OSE_signature.txt", 
                                package="consensusOV")

    sig <- read.delim(sig.file, as.is = TRUE)
    sig <- split(sig[,"ENTREZID"], sig[,"TISSUE"])
    
    # warn if certain signature genes are not present in the data
    rownames(expression.matrix) <- entrez.ids
    not.ft <- sum(!(sig$FT %in% rownames(expression.matrix)))
    if(not.ft) warning(paste(not.ft, "of", 
                                length(sig$FT), "FT genes not present"))

    not.ose <- sum(!(sig$OSE %in% rownames(expression.matrix)))    
    if(not.ose) warning(paste(not.ose, "of", 
                                length(sig$OSE), "OSE genes not present"))

    # scoring for one sample at a time
    .scoreSample <- function(evals)
    {   
        evals <- sort(evals)
        .getRank <- function(genes) match(genes, names(evals)) / length(evals)
        r <- lapply(sig, .getRank)
        nna <- sum(!is.na(unlist(r)))
        rs <-  sum(r[[1]], na.rm = TRUE) + sum(1 - r[[2]], na.rm = TRUE) 
        s <- 2 * rs / nna - 1 
        return(s)
    }   

    # apply to each sample & assign tissue of origin by thresholding
    scores <- apply(expression.matrix, 2, .scoreSample)
    tissues <- factor(ifelse(scores > 0, "FT", "OSE"))
    tscores <- list(tissues = tissues, scores = scores)

    return(tscores)
}

#' Get ovarian cancer subtypes as defined by Konecny et al., 2014
#'
#' @param expression.matrix A matrix of gene expression values with rows as
#' genes, columns as samples.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}
#' @return A list with first value \code{Konecny.subtypes} containing a factor
#' of subtype names; and second value \code{spearman.cc.vals} containing the
#' Spearman correlation values per subtype
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' get.konecny.subtypes(expression.matrix, entrez.ids)
#' @references Konecny et al. \emph{Prognostic and therapeutic relevance of
#' molecular subtypes in high-grade serous ovarian cancer.}
#' Journal of the National Cancer Institute (2014).
#' @export
get.konecny.subtypes <-
function(expression.matrix, entrez.ids) {

  expression.matrix <- t(scale(t(expression.matrix)))
  entrez.ids <- as.character(entrez.ids)
  ## Classify using nearest centroid with Spearman's rho
  intersecting.entrez.ids <- intersect(entrez.ids, rownames(konecny.centroids))

  konecny.centroids[rownames(konecny.centroids) %in% intersecting.entrez.ids,]
  konecny.centroids <- konecny.centroids[as.character(intersecting.entrez.ids),]
  expression.matrix <- expression.matrix[entrez.ids %in% intersecting.entrez.ids,]

  expression.matrix <- as.data.frame(expression.matrix)
  spearman.cc.vals <- sapply(
      konecny.centroids,
      function(x) sapply(expression.matrix,
                         function(y) cor(x, y , method="spearman")))

  ind <- apply(spearman.cc.vals, 1, which.max)
  subclasses <- colnames(spearman.cc.vals)[ind]
  subclasses <- factor(subclasses, levels=colnames(konecny.centroids))

  return(list(Konecny.subtypes=subclasses, spearman.cc.vals=spearman.cc.vals))
}

#' Get ovarian cancer subtypes as defined by Bentink et al., 2012
#'
#' @param expression.matrix A matrix of gene expression values with rows as
#' genes, columns as samples.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}
#' @return A list with first value \code{Bentink.subtypes} containing a factor
#' of subtype names; and second value \code{angio} containing the ouput of
#' \code{genefu::ovcAngiogenic}
#' @examples
#' library(Biobase)
#' library(genefu)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' get.bentink.subtypes(expression.matrix, entrez.ids)
#' @references Bentink et al. \emph{Angiogenic mRNA and microRNA gene expression
#'  signature predicts
#' a novel subtype of serous ovarian cancer.} PloS one (2012).
#' @export
get.bentink.subtypes <-
function(expression.matrix, entrez.ids) {
  ## Classify new samples
  entrez.ids <- as.character(entrez.ids)
  expression.matrix.t <- t(expression.matrix)
  annot <- as.data.frame(entrez.ids)
  colnames(annot) <- "entrezgene"
  rownames(annot) <- annot$entrezgene
  colnames(expression.matrix.t) <- rownames(annot)
  angio <- genefu::ovcAngiogenic(
      data = expression.matrix.t,
      annot=annot,
      gmap="entrezgene",
      do.mapping = TRUE
  )
  Bentink.subtypes <- angio$subtype$subtype
  return(list(Bentink.subtypes=Bentink.subtypes, angio=angio))
}

library(Biobase)
library(MetaGxOvarian)
library(gdata)
library(hgu133plus2.db)
library(GSVA)
source("../R/dataset.merging.R")
source("../R/get.helland.subtypes.R")
source("../R/get.konecny.subtypes.R")
source("../R/get.verhaak.subtypes.R")
source("../R/get.bentink.subtypes.R")
source("../R/get.subtypes.R")

#### Get gene sets, coefficients from supplemental files ###

## centroids.konecny

konecny.supplementary.data <- gdata::read.xls(
    system.file("extdata", "jnci_JNCI_14_0249_s05.xls", package="MetaGx"),
    sheet=4, stringsAsFactors=FALSE)

# Subset supplementary.data to consist of centroids with intersecting genes
konecny.centroids <- konecny.supplementary.data[,c(2,4:7)]
konecny.centroids[,2:5] <- sapply(
    konecny.centroids[,2:5],
    function(x) ave(x, konecny.centroids$EntrezGeneID, FUN=mean))
konecny.centroids <- unique(konecny.centroids)
rownames(konecny.centroids) <- konecny.centroids$EntrezGeneID
konecny.centroids <- konecny.centroids[,-1]

## entrez.id.logFC.list.helland
helland.supplementary.type.1 <- gdata::read.xls(
    system.file("extdata", "journal.pone.0018064.s015.XLS", package="MetaGx"),
    sheet=1, stringsAsFactors=FALSE)
helland.supplementary.type.2 <- gdata::read.xls(
    system.file("extdata", "journal.pone.0018064.s015.XLS", package="MetaGx"),
    sheet=2, stringsAsFactors=FALSE)
helland.supplementary.type.4 <- gdata::read.xls(
    system.file("extdata", "journal.pone.0018064.s015.XLS", package="MetaGx"),
    sheet=3, stringsAsFactors=FALSE)
helland.supplementary.type.5 <- gdata::read.xls(
    system.file("extdata", "journal.pone.0018064.s015.XLS", package="MetaGx"),
    sheet=4, stringsAsFactors=FALSE)
helland.supplementary.tables <- list(
    C1=helland.supplementary.type.1,
    C2=helland.supplementary.type.2,
    C4=helland.supplementary.type.4,
    C5=helland.supplementary.type.5)

entrez.id.logFC.list.helland <- lapply(helland.supplementary.tables,
                                       function(x) {
  ## Use the supplementary table's listed probe id and gene name to determine
  # the Entrez ID

  # If there is only one EntrezID that maps to a probe in hgu133plus2.db, use
  # that Entrez ID.

  # If there are multiple EntrezIDs that map to a probe, then use the EntrezID
  #(if any) that corresponds to the provided gene symbol.
  current.mapping <- suppressWarnings(
      AnnotationDbi::select(hgu133plus2.db, as.character(x$ID),
                            c("ENTREZID", "SYMBOL")))
  current.mapping <- current.mapping[ !is.na(current.mapping$ENTREZID), ]
  colnames(x)[1:2] <- c("PROBEID", "SYMBOL")
  mappings.with.unique.probeid <- current.mapping[ !(current.mapping$PROBEID %in% current.mapping$PROBEID[duplicated(current.mapping$PROBEID)]),]
  mappings.with.duplicate.probeid <- current.mapping[ current.mapping$PROBEID %in% current.mapping$PROBEID[duplicated(current.mapping$PROBEID)],]
  mappings.with.duplicate.probeid <- merge(x, mappings.with.duplicate.probeid, by=c("PROBEID", "SYMBOL"))[, c("PROBEID", "ENTREZID", "SYMBOL")]
  mappings.with.duplicate.probeid <- unique(mappings.with.duplicate.probeid)
  current.mapping <- rbind(mappings.with.unique.probeid, mappings.with.duplicate.probeid)
  to.return <- merge(x, current.mapping, by="PROBEID")[, c("ENTREZID", "PROBEID", "logFC")]
  return(to.return)
})

helland.gene.set <- Reduce(function(x,y) union(x, y),
                           lapply(entrez.id.logFC.list.helland,
                           function (x) x$ENTREZID))

## verhaak.genesets.entrez.ids
verhaak.supplementary.data.sheet7 <- read.xls(
    system.file("extdata", "JCI65833sd1.xls", package="MetaGx"),
    sheet=7, skip=1)

verhaak.gene.symbols <- lapply(levels(
    verhaak.supplementary.data.sheet7$CLASS),
    function(y) as.character(
        verhaak.supplementary.data.sheet7[
            verhaak.supplementary.data.sheet7$CLASS==y,1
        ]
    )
)


names(verhaak.gene.symbols) <- levels(verhaak.supplementary.data.sheet7$CLASS)

verhaak.genesets.entrez.ids <- lapply(
    verhaak.gene.symbols,
    function(gene.names) do.call(c, as.list(org.Hs.egALIAS2EG)[gene.names]))

## esets.rescaled.classified.filteredgenes
## consensus.training.dataset.full

verhaak.entrez.ids <- unlist(verhaak.genesets.entrez.ids)


##### Get classified datasets for consensus subtype classifier #####

remove.retracted <- FALSE
remove.subsets <- TRUE
probe.gene.mapping <- TRUE
keep.common.only <- FALSE
#only keep studies with at least this many samples
min.sample.size <- 40   
quantile.cutoff <- 0
strict.checking <- FALSE
remove.duplicates <- TRUE

rule.1 <- c("sample_type","^tumor$")
rule.2 <- c("histological_type","^ser$")
rule.3 <- c("summarystage","^late$")
rule.4 <- c("summarygrade","^high$")

rescale <- FALSE
# only keep esets with at least 10000 genes
min.number.of.genes <- 10000

source(system.file("extdata", "createEsetList.R", package="MetaGxOvarian"))

esets.not.rescaled <- esets
# remove any genes with NA values
esets.not.rescaled <- lapply(esets.not.rescaled, function(eset) eset[apply(exprs(eset), 1, function(x) all(!is.na(x))), ])

esets.not.rescaled <- esets.not.rescaled[sapply(esets.not.rescaled, function(eset) nrow(eset) > 10000)]

# Classify data
set.seed(450)

# Subtype classification
if(file.exists("esets.not.rescaled.classified.RData")) {
  load("esets.not.rescaled.classified.RData")
} else {
  esets.not.rescaled.classified <- esets.not.rescaled
  # Remove TCGA.RNASeqV2
  esets.not.rescaled.classified <- esets.not.rescaled.classified[names(esets.not.rescaled.classified) != "TCGA.RNASeqV2"]
  
  esets.not.rescaled.classified <- lapply(esets.not.rescaled.classified, function(eset) {
    konecny.out <- get.subtypes(eset, method = "Konecny")
    annotated.eset <- eset
    annotated.eset$Konecny.subtypes <- konecny.out$Konecny.subtypes
    annotated.eset$Konecny.margins <- apply(konecny.out$spearman.cc.vals, 1, function(x) max(x) - sort(x)[3])
    return(annotated.eset)
  })
  esets.not.rescaled.classified <- lapply(esets.not.rescaled.classified, function(eset) {
    verhaak.out <- get.subtypes(eset, method = "Verhaak")
    annotated.eset <- eset
    annotated.eset$Verhaak.subtypes <- verhaak.out$Verhaak.subtypes
    annotated.eset$Verhaak.margins <- apply(verhaak.out$gsva.out, 1, function(x) max(x) - sort(x)[3])
    return(annotated.eset)
  })
  esets.not.rescaled.classified <- lapply(esets.not.rescaled.classified, function(eset) {
    helland.out <- get.subtypes(eset, method = "Helland")
    annotated.eset <- eset
    annotated.eset$Helland.subtypes <- helland.out$Helland.subtypes
    annotated.eset$Helland.margins <- apply(helland.out$subtype.scores, 1, function(x) max(x) - sort(x)[3])
    return(annotated.eset)
  })
  #esets.not.rescaled.classified <- lapply(esets.not.rescaled.classified, function(eset) getBentinkSubtypes(eset)[[1]])
  save(esets.not.rescaled.classified, file = "esets.not.rescaled.classified.RData")
}


esets.rescaled.classified <- lapply(esets.not.rescaled.classified,
                                    function(eset) {
                                        exprs(eset) <- t(scale(t(exprs(eset))))
                                        eset
                                    }
                            )

esets.rescaled.classified.filteredgenes <- lapply (
    esets.rescaled.classified,
    function(eset) {
        eset <- eset[
            as.character(fData(eset)$EntrezGene.ID) %in% as.character(verhaak.entrez.ids),
        ]
    }
)


consensus.training.dataset.full <- dataset.merging(
    esets.rescaled.classified.filteredgenes,
    method = "intersect",
    standardization = "none"
)

save(
  "konecny.centroids",
  "entrez.id.logFC.list.helland",
  "verhaak.genesets.entrez.ids",
  "esets.rescaled.classified.filteredgenes",
  "consensus.training.dataset.full",
  file="sysdata.rda", compress='xz')

## GSE14764.eset
GSE14764.eset <- esets.not.rescaled$GSE14764

# Only keep genes relevant for examples
entrez.id.union <- c(
    as.character(
        unlist(lapply(entrez.id.logFC.list.helland, function(x) x$ENTREZID))
    ),
    unlist(verhaak.genesets.entrez.ids),
    rownames(konecny.centroids)
)

GSE14764.eset <- GSE14764.eset[fData(GSE14764.eset)$EntrezGene.ID %in% entrez.id.union,]

save(GSE14764.eset, file="GSE14764.eset.RData", compress='xz')

#' Sample ExpressionSet from MetaGxOvarian
#'
#' A Biobase::ExpressionSet from package MetaGxOvarian for the 
#' dataset GSE14764
#'
#' @format A Biobase::ExpressionSet object
#' @source \url{http://biorxiv.org/content/biorxiv/early/2016/05/12/052910.full.pdf}
"GSE14764.eset"

#' Get consensusOV ovarian cancer subtypes
#'
#' @param expression.matrix A matrix of gene expression values with rows as
#' genes, columns as samples.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}
#' @param concordant.tumors.only Logical. Should the classifier trained only on 
#' tumors that are concordantly classified by Helland, Konecny, and Verhaak?
#' Defaults to TRUE.
#' @param remove.using.cutoff Specify whether to classify NA for samples that do
#'  not meet a margin cutoff
#' @param percentage.dataset.removed If remove.using.cutoff is TRUE, then
#' classify this percentage of samples to NA based on margin values
#' @param .training.dataset ExpressionSet containing the training data. 
#' Defaults to the pooled dataset across selected MetaGxOvarian datasets.
#' @param .dataset.names.to.keep Names of MetaGxOvarian datasets to use for
#' training
#' @param rf.probs random forest probabilities for each subtype as returned
#' by \code{\link{get.consensus.subtypes}}
#' @return \code{get.consensus.subtypes} returns a list with 
#' first value \code{consensusOV.subtypes} containing a
#' factor of subtype labels; and second value \code{rf.probs} containing a matrix
#' of subtype probabilities.
#'
#' \code{margin} returns a numeric vector containing the classification margin 
#' scores, i.e. the difference between the top two subtype scores for each tumor.
#'
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' sts <- get.consensus.subtypes(expression.matrix, entrez.ids)
#' margins <- margin(sts$rf.probs)
#'
#' @importFrom randomForest randomForest
#' @importFrom stats cor ecdf predict quantile sd
#' @importFrom utils combn
#'
#' @export
get.consensus.subtypes <- function(expression.matrix, entrez.ids,
    concordant.tumors.only=TRUE, remove.using.cutoff=FALSE,
    percentage.dataset.removed=0.75,
    .training.dataset=consensus.training.dataset.full,
    .dataset.names.to.keep=names(esets.rescaled.classified.filteredgenes)) 
{

  ### Load training data
  message("Loading training data")
  expression.matrix <- t(scale(t(expression.matrix)))
  entrez.ids <- as.character(entrez.ids)

  # use full training dataset or only specified datasets?
  dataset.names.to.keep <- .dataset.names.to.keep
  cond1 <- length(dataset.names.to.keep) == length(esets.rescaled.classified.filteredgenes)
  cond2 <- all(dataset.names.to.keep == names(esets.rescaled.classified.filteredgenes))
  if(cond1 && cond2) 
  {
    # Using all datasets
    # use consensustraining.dataset.full
    # This file is produced from classificationAcrossDatasets.Rnw
    training.dataset <- .training.dataset
  } else{
    esets.training <- esets.rescaled.classified.filteredgenes[dataset.names.to.keep]
    training.dataset <- dataset.merging(esets.training, method = "intersect",
                                    standardization = "none")
  }

  # restrict training to concordant tumors?   
  if(concordant.tumors.only)
  {    
    subtype.correspondances <- data.frame(
        Konecny=c("C1_immL", "C2_diffL", "C3_profL", "C4_mescL"),
        Verhaak=c("IMR", "DIF", "PRO", "MES"),
        Helland=c("C2", "C4", "C5", "C1")
    )
    cases.to.keep <-
      match(training.dataset$Konecny.subtypes, subtype.correspondances$Konecny) ==
      match(training.dataset$Verhaak.subtypes, subtype.correspondances$Verhaak) &
      match(training.dataset$Verhaak.subtypes, subtype.correspondances$Verhaak) ==
      match(training.dataset$Helland.subtypes, subtype.correspondances$Helland)
    training.dataset <- training.dataset[,cases.to.keep]
  }  

  train.labels <- training.dataset$Verhaak.subtypes
  levels(train.labels) <- paste0(levels(train.labels), "_consensus")

  intersecting.entrez.ids <- as.character(
      intersect(fData(training.dataset)$EntrezGene.ID, entrez.ids)
  )

  message("Training Random Forest...")

  eids <- fData(training.dataset)$EntrezGene.ID
  ind <- match(intersecting.entrez.ids, eids)
  train.expression.matrix <- t(exprs(training.dataset)[ind,])

  comb.mat <- combn(seq_along(intersecting.entrez.ids), 2)
  train.pairwise.matrix <- apply(comb.mat, 2, function(pair) 
  	train.expression.matrix[,pair[1]] > train.expression.matrix[,pair[2]])
  train.pairwise.vals <- as.data.frame(train.pairwise.matrix)

  rf.model <- randomForest(x=train.pairwise.vals, y=train.labels)

  ind <- match(intersecting.entrez.ids, entrez.ids)
  test.expression.matrix <- t(expression.matrix[ind,])

  comb.mat <- combn(seq_along(intersecting.entrez.ids), 2)
  test.pairwise.matrix <- apply(comb.mat, 2, function(pair) 
    test.expression.matrix[,pair[1]] > test.expression.matrix[,pair[2]])
  test.pairwise.vals <- as.data.frame(test.pairwise.matrix)

  my.predictions <- predict(rf.model, newdata = test.pairwise.vals)
  my.predictions.probs <- predict(rf.model,
                                  newdata = test.pairwise.matrix,
                                  type = 'prob')

  if(remove.using.cutoff) {
   	subtr <- apply(my.predictions.probs, 1, function(row) sort(row)[3])
	my.predictions.margins <- rowMax(my.predictions.probs) - subtr    
	ecdf.evaluated <- ecdf(my.predictions.margins)(my.predictions.margins)
    na.ind <- ecdf.evaluated < percentage.dataset.removed
    my.predictions[na.ind] <- NA
  }

  names(my.predictions) <- NULL
  my.predictions <- factor(my.predictions, levels=c("IMR_consensus",
                                                    "DIF_consensus",
                                                    "PRO_consensus",
                                                    "MES_consensus"))

  return(list(consensusOV.subtypes=my.predictions, rf.probs=my.predictions.probs))
}

#' @rdname get.consensus.subtypes
#' @export
margin <- function(rf.probs)
{
    subtr <- apply(rf.probs, 1, function(row) sort(row)[3])
    pred.margins <- Biobase::rowMax(rf.probs) - subtr
    return(pred.margins)
}

#' Get ovarian cancer subtypes as defined by Verhaak et al., 2013
#'
#' @param expression.matrix A matrix of gene expression values with rows as
#' genes, columns as samples.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}
#' @return A list with first value \code{Verhaak.subtypes} containing a factor
#' of subtype names; and second value \code{gsva} containing the GSVA subtype
#' scores
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- paste0("geneid.", as.character(fData(GSE14764.eset)$EntrezGene.ID))
#' get.konecny.subtypes(expression.matrix, entrez.ids)
#' @references Verhaak et al. \emph{Prognostically relevant gene signatures of
#' high-grade serous ovarian carcinoma.}
#' The Journal of Clinical Investigation (2013)
#' @importFrom GSVA gsva
#' @export
get.verhaak.subtypes <- function(expression.matrix, entrez.ids) {
  # entrez.ids <- as.character(entrez.ids)
  # rownames(expression.matrix) <- entrez.ids
  
  # names(entrez.ids) <- entrez.ids
  gsva.expr <- GSVA::ssgseaParam(
    exprData = expression.matrix, 
    geneSets = verhaak.genesets.entrez.ids, #list(set1 = entrez.ids),
    normalize=FALSE
  )

  gsva.out <- GSVA::gsva(
    param = gsva.expr,
    verbose= TRUE,
    BPPARAM = BiocParallel::MulticoreParam(2))

  # ## Get ssGSEA subtype scores
  # gsva.out <- gsva(expression.matrix, verhaak.genesets.entrez.ids,
  #                  method="ssgsea", tau=0.75, parallel.sz=4, mx.diff=FALSE,
  #                  ssgsea.norm=FALSE)
  gsva.out <- t(gsva.out)
  #gsva.out <- apply(gsva.out, 2,
  #                  function(x) ( x - min(x) ) / ( max(x) - min(x) ))
  # making this more efficient:	 	
  minM <- matrixStats::colMins(gsva.out)
  maxM <- matrixStats::colMaxs(gsva.out)
  diffMM <- maxM - minM

  gsva.out <- sweep(gsva.out, 2, minM)
  gsva.out <- sweep(gsva.out, 2, diffMM, FUN="/")
		
  ## Classify each sample according to the max ssGSEA subtype score
  ind <- apply(gsva.out, 1, which.max)
  subclasses <- colnames(gsva.out)[ind]
  subclasses <- factor(subclasses, levels=c("IMR", "DIF", "PRO", "MES"))

  ## Append a new column for Verhaak subtypes
  return(list(Verhaak.subtypes=subclasses, gsva.out=gsva.out))
}

#' Get ovarian cancer subtypes as defined by Helland et al., 2011
#'
#' @param expression.matrix A matrix of gene expression values with rows as
#' genes, columns as samples.
#' @param entrez.ids A vector of Entrez Gene IDs, corresponding to the rows of
#' \code{expression.matrix}
#' @return A list with first value \code{Helland.subtypes} containing a factor
#' of subtype names; and second value \code{subtype.scores} containing a matrix
#' of subtype scores
#' @examples
#' library(Biobase)
#' data(GSE14764.eset)
#' expression.matrix <- exprs(GSE14764.eset)
#' entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
#' get.helland.subtypes(expression.matrix, entrez.ids)
#' @references Helland et al. \emph{Deregulation of MYCN, LIN28B and LET7 in a
#' molecular subtype of aggressive high-grade serous ovarian cancers.}
#' PloS one (2011).
#' @export
get.helland.subtypes <-
function(expression.matrix, entrez.ids) {

  entrez.ids <- as.character(entrez.ids)
  eids <- lapply(entrez.id.logFC.list.helland, function (x) x$ENTREZID)
  helland.gene.set <- Reduce(function(x,y) union(x, y), eids)
  intersecting.entrez.ids <- intersect(helland.gene.set, entrez.ids)

  # Only keep genes present in both the supplementary and this eset
  entrez.id.logFC.list <- lapply(
      entrez.id.logFC.list.helland,
      function(x) x[x$ENTREZID %in% intersecting.entrez.ids, ])

  subtype.scores <- sapply(entrez.id.logFC.list, function(x) {
    ordered.expression.subset <- expression.matrix[match(x$ENTREZID, entrez.ids),]
	res <- colSums(ordered.expression.subset * x$logFC)
    return(res)
  })

  old.rownames <- rownames(subtype.scores)
  # Scale to mean=0, variance=1
  subtype.scores <- apply(subtype.scores, 2, scale)
  rownames(subtype.scores) <- old.rownames

  ind <- apply(subtype.scores, 1, which.max)
  subclasses <- colnames(subtype.scores)[ind]	
  subclasses <- factor(subclasses, levels=c("C2", "C4", "C5", "C1"))

  return(list(Helland.subtypes=subclasses, subtype.scores=subtype.scores))
}

---
title: "Molecular subtyping for ovarian cancer"
author: "Gregory M Chen"
package: consensusOV
output:
    BiocStyle::html_document:
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Molecular subtyping for ovarian cancer}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, cache=TRUE)
```

# Introduction

`r Biocpkg("consensusOV")` is a package for molecular subtyping for ovarian cancer. It is intended for whole-transcriptome gene expression datasets from patients with high-grade serous ovarian carcinoma. This package includes implementations of four previously published subtype classifiers 
([Helland et al., 2011](https://doi.org/10.1371/journal.pone.0018064);
[Bentink et al., 2012](https://doi.org/10.1371/journal.pone.0030269);
[Verhaak et al., 2013](https://doi.org/10.1172/JCI65833);
[Konecny et al., 2014](https://doi.org/10.1093/jnci/dju249))
and a consensus random forest classifier ([Chen et al., 2018](https://doi.org/10.1158/1078-0432.CCR-18-0784)).

The `get.subtypes()` function is a wrapper for the other package subtyping functions  `get.consensus.subtypes()`, `get.konecny.subtypes()`, `get.verhaak.subtypes()`,
`get.bentink.subtypes()`, `get.helland.subtypes()`. It can take as input either a matrix of gene expression values and a vector of Entrez IDs; or an `ExpressionSet` from the `r Biocpkg("Biobase")` package. If `expression.dataset` is a matrix, it should be formatted with genes as rows and patients as columns; and `entrez.ids` should be a vector with length the same as `nrow(expression.dataset)`. The `method` argument specifies which of the five subtype classifiers to use.

# Load Data
```{r load_pkgs, message=FALSE}
library(consensusOV)
library(Biobase)
library(genefu)
```

The package contains a subset of the ovarian cancer microarray dataset
[GSE14764](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE14764) as example data.
```{r load_data, message=FALSE}
data(GSE14764.eset)
dim(GSE14764.eset)
GSE14764.expression.matrix <- exprs(GSE14764.eset)
GSE14764.expression.matrix[1:5,1:5]
GSE14764.entrez.ids <- fData(GSE14764.eset)$EntrezGene.ID
head(GSE14764.entrez.ids)
```

# Subtyping

```{r subtyping}
bentink.subtypes <- get.subtypes(GSE14764.eset, method = "Bentink")
bentink.subtypes$Bentink.subtypes
konecny.subtypes <- get.subtypes(GSE14764.eset, method = "Konecny")
konecny.subtypes$Konecny.subtypes
helland.subtypes <- get.subtypes(GSE14764.eset, method = "Helland")
helland.subtypes$Helland.subtypes
```

```{r subtyping2, results="hide"}

# to align with the Verhaak subtypes, we need to remove the "geneid." in the rownames
temp_eset <- GSE14764.eset
rownames(temp_eset) <- gsub("geneid.", "", rownames(temp_eset))

verhaak.subtypes <- get.subtypes(temp_eset, method = "Verhaak")
```

```{r subtyping3}
verhaak.subtypes$Verhaak.subtypes
consensus.subtypes <- get.subtypes(GSE14764.eset, method = "consensusOV")
consensus.subtypes$consensusOV.subtypes
```

```{r alternative_subtyping}
## Alternatively, e.g.
data(sigOvcAngiogenic)
bentink.subtypes <- get.subtypes(GSE14764.expression.matrix, GSE14764.entrez.ids, method = "Bentink")
```

Each subtyping function outputs a list with two values. The first value is a factor of subtype labels. The second is an classifier-specific values. For the Konecny, Helland, Verhaak, and Consensus classifiers, this object is a dataframe with subtype specific scores. For the Bentink classifier, the object is the output of the `genefu` function call. 

Subtype classifiers can alternatively be called using inner functions.

```{r subtyping_ex_2}
bentink.subtypes <- get.bentink.subtypes(GSE14764.expression.matrix, GSE14764.entrez.ids)
```

# Subtype Scores

The Konecny, Helland, Verhaak, and Consensus classifiers produce real-valued subtype scores. We can use these in various ways - for example, here, we compute correlations between correspinding subtype scores.

We can compare the subtype scores between the Verhaak and Helland classifiers:

```{r verhaak_helland, fig.height = 8, fig.width = 8}
vest <- verhaak.subtypes$gsva.out
vest <- vest[,c("IMR", "DIF", "PRO", "MES")]
hest <- helland.subtypes$subtype.scores
hest <- hest[, c("C2", "C4", "C5", "C1")]
dat <- data.frame(
	as.vector(vest), 
	rep(colnames(vest), each=nrow(vest)),
	as.vector(hest), 
	rep(colnames(hest), each=nrow(hest)))
colnames(dat) <- c("Verhaak", "vsc", "Helland", "hsc")
## plot
library(ggplot2)
ggplot(dat, aes(Verhaak, Helland)) + geom_point() + facet_wrap(vsc~hsc, nrow = 2, ncol = 2)
```

Corresponding correlation values are 
`r round(cor(verhaak.subtypes$gsva.out[,"DIF"], helland.subtypes$subtype.scores[,"C4"]), digits=2)`, 
`r round(cor(verhaak.subtypes$gsva.out[,"IMR"], helland.subtypes$subtype.scores[,"C2"]), digits=2)`,
`r round(cor(verhaak.subtypes$gsva.out[,"MES"], helland.subtypes$subtype.scores[,"C1"]), digits=2)`, and 
`r round(cor(verhaak.subtypes$gsva.out[,"PRO"], helland.subtypes$subtype.scores[,"C5"]), digits=2)`.

Likewise, we can compare the subtype scores between the Konecny and Helland classifier:

```{r konecny_helland, fig.height = 8, fig.width = 8}
kost <- konecny.subtypes$spearman.cc.vals
hest <- helland.subtypes$subtype.scores
hest <- hest[, c("C2", "C4", "C5", "C1")]
dat <- data.frame(
	as.vector(kost), 
	rep(colnames(kost), each=nrow(kost)),
	as.vector(hest), 
	rep(colnames(hest), each=nrow(hest)))
colnames(dat) <- c("Konecny", "ksc", "Helland", "hsc")
## plot
ggplot(dat, aes(Konecny, Helland)) + geom_point() + facet_wrap(ksc~hsc, nrow = 2, ncol = 2)
```

Corresponding correlation values are 
`r round(cor(konecny.subtypes$spearman.cc.vals[,"C1_immL"], helland.subtypes$subtype.scores[,"C2"]), digits=2)`, 
`r round(cor(konecny.subtypes$spearman.cc.vals[,"C2_diffL"], helland.subtypes$subtype.scores[,"C4"]), digits=2)`, 
`r round(cor(konecny.subtypes$spearman.cc.vals[,"C3_profL"], helland.subtypes$subtype.scores[,"C5"]), digits=2)`, 
and `r round(cor(konecny.subtypes$spearman.cc.vals[,"C4_mescL"], helland.subtypes$subtype.scores[,"C1"]), digits=2)`.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataset.merging.R
\name{dataset.merging}
\alias{dataset.merging}
\title{Merging all individual esets and merging them into a big eset}
\usage{
dataset.merging(
  esets,
  method = c("union", "intersect"),
  standardization = c("quantile", "robust.scaling", "scaling", "none"),
  nthread = 1
)
}
\arguments{
\item{esets}{The list containing all GSE file that need to be merged.}

\item{method}{either "unique" or "intersect" is use to for selecting geneid}

\item{standardization}{choose between "quantile", "robust.scaling", "scaling"
or "none"}

\item{nthread}{number of threads (1 by default)}
}
\value{
The merging eset
}
\description{
Merging all individual esets and merging them into a big eset
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{GSE14764.eset}
\alias{GSE14764.eset}
\title{Sample ExpressionSet from MetaGxOvarian}
\format{
A Biobase::ExpressionSet object
}
\source{
\url{http://biorxiv.org/content/biorxiv/early/2016/05/12/052910.full.pdf}
}
\usage{
GSE14764.eset
}
\description{
A Biobase::ExpressionSet from package MetaGxOvarian for the 
dataset GSE14764
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get.hao.subtypes.R
\name{get.hao.subtypes}
\alias{get.hao.subtypes}
\title{Get ovarian cancer subtypes as defined by Hao et al., 2017}
\usage{
get.hao.subtypes(expression.matrix, entrez.ids)
}
\arguments{
\item{expression.matrix}{A matrix of gene expression values with genes as
rows, samples as columns.}

\item{entrez.ids}{A vector of Entrez Gene IDs, corresponding to the rows of
\code{expression.matrix}.}
}
\value{
A list with first value \code{tissue} containing a factor
of subtype names (tissue of origin); and second value \code{score} containing
the tissue-of-origin score.
}
\description{
Get ovarian cancer subtypes as defined by Hao et al., 2017
}
\details{
Hao et al., 2017 derived a gene signature to predict the tissue 
of origin of ovarian tumors as either fallopian tube (FT) or ovarian surface
epithelium (OSE).

The authors found that expression patterns of tissue-specific genes, prognostic
genes, and molecular markers support a dualistic tissue origin of ovarian cancer, 
from either FT or OSE.

The subtype classifier considers 112 signature genes including 37 genes
upregulated in FT and 75 genes upregulated in OSE. A score is computed
that is designed to range from 0 to 1 for FT tumors, while OSE tumors have a 
score ranging from -1 to 0.
}
\examples{
library(Biobase)
data(GSE14764.eset)
expression.matrix <- exprs(GSE14764.eset)
entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
get.hao.subtypes(expression.matrix, entrez.ids)
}
\references{
Hao et al. (2017) Integrated analysis reveals tubal- and
ovarian-originated serous ovarian cancer and predicts differential therapeutic
responses. Clinical Cancer Research, 23:7400-11.
}
\author{
Ludwig Geistlinger
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get.konecny.subtypes.R
\name{get.konecny.subtypes}
\alias{get.konecny.subtypes}
\title{Get ovarian cancer subtypes as defined by Konecny et al., 2014}
\usage{
get.konecny.subtypes(expression.matrix, entrez.ids)
}
\arguments{
\item{expression.matrix}{A matrix of gene expression values with rows as
genes, columns as samples.}

\item{entrez.ids}{A vector of Entrez Gene IDs, corresponding to the rows of
\code{expression.matrix}}
}
\value{
A list with first value \code{Konecny.subtypes} containing a factor
of subtype names; and second value \code{spearman.cc.vals} containing the
Spearman correlation values per subtype
}
\description{
Get ovarian cancer subtypes as defined by Konecny et al., 2014
}
\examples{
library(Biobase)
data(GSE14764.eset)
expression.matrix <- exprs(GSE14764.eset)
entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
get.konecny.subtypes(expression.matrix, entrez.ids)
}
\references{
Konecny et al. \emph{Prognostic and therapeutic relevance of
molecular subtypes in high-grade serous ovarian cancer.}
Journal of the National Cancer Institute (2014).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get.subtypes.R
\name{get.subtypes}
\alias{get.subtypes}
\title{Get ovarian cancer subtypes}
\usage{
get.subtypes(
  expression.dataset,
  entrez.ids = NULL,
  method = c("consensusOV", "Helland", "Verhaak", "Konecny", "Bentink"),
  ...
)
}
\arguments{
\item{expression.dataset}{Either a matrix of gene expression values with rows
 as genes, columns as samples;
or a BioBase::ExpressionSet object from MetaGxOvarian.
If \code{expression.dataset} is a matrix, then \code{entrez.ids} must have
length equal to the number of rows of \code{expression.dataset}.}

\item{entrez.ids}{A vector of Entrez Gene IDs, corresponding to the rows of
\code{expression.dataset}}

\item{method}{The subtyping method to use}

\item{...}{Optional parameters to be passed to the low level function}
}
\value{
A list with first value \code{Konecny.subtypes} containing a factor
of subtype names; and second value \code{spearman.cc.vals} containing the
Spearman correlation values per subtype
}
\description{
Get ovarian cancer subtypes
}
\examples{
library(Biobase)
data(GSE14764.eset)
expression.matrix <- exprs(GSE14764.eset)
entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
get.subtypes(expression.matrix, entrez.ids, method="Konecny")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get.bentink.subtypes.R
\name{get.bentink.subtypes}
\alias{get.bentink.subtypes}
\title{Get ovarian cancer subtypes as defined by Bentink et al., 2012}
\usage{
get.bentink.subtypes(expression.matrix, entrez.ids)
}
\arguments{
\item{expression.matrix}{A matrix of gene expression values with rows as
genes, columns as samples.}

\item{entrez.ids}{A vector of Entrez Gene IDs, corresponding to the rows of
\code{expression.matrix}}
}
\value{
A list with first value \code{Bentink.subtypes} containing a factor
of subtype names; and second value \code{angio} containing the ouput of
\code{genefu::ovcAngiogenic}
}
\description{
Get ovarian cancer subtypes as defined by Bentink et al., 2012
}
\examples{
library(Biobase)
library(genefu)
data(GSE14764.eset)
expression.matrix <- exprs(GSE14764.eset)
entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
get.bentink.subtypes(expression.matrix, entrez.ids)
}
\references{
Bentink et al. \emph{Angiogenic mRNA and microRNA gene expression
 signature predicts
a novel subtype of serous ovarian cancer.} PloS one (2012).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get.consensus.subtypes.R
\name{get.consensus.subtypes}
\alias{get.consensus.subtypes}
\alias{margin}
\title{Get consensusOV ovarian cancer subtypes}
\usage{
get.consensus.subtypes(
  expression.matrix,
  entrez.ids,
  concordant.tumors.only = TRUE,
  remove.using.cutoff = FALSE,
  percentage.dataset.removed = 0.75,
  .training.dataset = consensus.training.dataset.full,
  .dataset.names.to.keep = names(esets.rescaled.classified.filteredgenes)
)

margin(rf.probs)
}
\arguments{
\item{expression.matrix}{A matrix of gene expression values with rows as
genes, columns as samples.}

\item{entrez.ids}{A vector of Entrez Gene IDs, corresponding to the rows of
\code{expression.matrix}}

\item{concordant.tumors.only}{Logical. Should the classifier trained only on 
tumors that are concordantly classified by Helland, Konecny, and Verhaak?
Defaults to TRUE.}

\item{remove.using.cutoff}{Specify whether to classify NA for samples that do
not meet a margin cutoff}

\item{percentage.dataset.removed}{If remove.using.cutoff is TRUE, then
classify this percentage of samples to NA based on margin values}

\item{.training.dataset}{ExpressionSet containing the training data. 
Defaults to the pooled dataset across selected MetaGxOvarian datasets.}

\item{.dataset.names.to.keep}{Names of MetaGxOvarian datasets to use for
training}

\item{rf.probs}{random forest probabilities for each subtype as returned
by \code{\link{get.consensus.subtypes}}}
}
\value{
\code{get.consensus.subtypes} returns a list with 
first value \code{consensusOV.subtypes} containing a
factor of subtype labels; and second value \code{rf.probs} containing a matrix
of subtype probabilities.

\code{margin} returns a numeric vector containing the classification margin 
scores, i.e. the difference between the top two subtype scores for each tumor.
}
\description{
Get consensusOV ovarian cancer subtypes
}
\examples{
library(Biobase)
data(GSE14764.eset)
expression.matrix <- exprs(GSE14764.eset)
entrez.ids <- as.character(fData(GSE14764.eset)$EntrezGene.ID)
sts <- get.consensus.subtypes(expression.matrix, entrez.ids)
margins <- margin(sts$rf.probs)

}
